'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var OffCanvas = function (_Component) {
  _inherits(OffCanvas, _Component);

  function OffCanvas(props) {
    _classCallCheck(this, OffCanvas);

    var _this = _possibleConstructorReturn(this, (OffCanvas.__proto__ || Object.getPrototypeOf(OffCanvas)).call(this, props));

    _this.state = {
      startMove: null,
      lastMove: null,
      xOffset: 0,
      isMenuOpen: false
    };
    _this.sideGrabWidth = props.sideGrabWidth || 40;
    _this.tollerance = props.tollerance || 70;
    _this.defaultMenuWidth = 170;
    _this.touchStartHandler = _this.touchStartHandler.bind(_this);
    _this.touchEndHandler = _this.touchEndHandler.bind(_this);
    _this.touchMoveHandler = _this.touchMoveHandler.bind(_this);
    _this.openMenu = _this.openMenu.bind(_this);
    _this.closeMenu = _this.closeMenu.bind(_this);
    _this.trackMenuPosition = _this.trackMenuPosition.bind(_this);
    _this.funcNullCheck = _this.funcNullCheck.bind(_this);
    return _this;
  }

  _createClass(OffCanvas, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.forceOpenState) {
        this.openMenu();
      }
    }
  }, {
    key: 'UNSAFE_componentWillReceiveProps',
    value: function UNSAFE_componentWillReceiveProps(newProps) {
      if (newProps.forceOpenState === true && newProps.forceOpenState !== this.props.forceOpenState && this.state.isMenuOpen === false) {
        this.openMenu();
      } else if (newProps.forceOpenState === false && newProps.forceOpenState !== this.props.forceOpenState && this.state.isMenuOpen === true) {
        this.closeMenu();
      }

      if (this.props.menuWidth !== newProps.menuWidth && newProps.forceOpenState === true) {
        this.setState({
          xOffset: newProps.menuWidth
        });
      }
    }
  }, {
    key: 'touchStartHandler',
    value: function touchStartHandler(e) {
      var isMenuOpen = this.state.isMenuOpen;

      var xCoord = e.touches[0].clientX;

      if (isMenuOpen || !isMenuOpen && xCoord <= this.sideGrabWidth) {
        this.setState({ startMove: xCoord });
      }
    }
  }, {
    key: 'touchEndHandler',
    value: function touchEndHandler() {
      var _state = this.state,
          startMove = _state.startMove,
          lastMove = _state.lastMove,
          isMenuOpen = _state.isMenuOpen;

      var dragDistance = lastMove - startMove;
      var invertedDragDistance = dragDistance * -1;

      if (!isMenuOpen && startMove && lastMove && dragDistance >= this.tollerance) {
        this.openMenu();
      } else if (!isMenuOpen && startMove && lastMove && dragDistance < this.tollerance) {
        this.closeMenu();
      }
      if (isMenuOpen && startMove && lastMove && invertedDragDistance >= this.tollerance) {
        this.closeMenu();
      } else if (isMenuOpen && startMove && lastMove && invertedDragDistance < this.tollerance) {
        this.openMenu();
      }
    }
  }, {
    key: 'touchMoveHandler',
    value: function touchMoveHandler(e) {
      var _state2 = this.state,
          startMove = _state2.startMove,
          isMenuOpen = _state2.isMenuOpen;

      var touchX = e.touches[0].clientX;

      if (isMenuOpen || !isMenuOpen && startMove && startMove <= this.sideGrabWidth) {
        this.trackMenuPosition(touchX);
      }
    }
  }, {
    key: 'funcNullCheck',
    value: function funcNullCheck(fn) {
      if (fn) {
        fn();
      }
    }
  }, {
    key: 'openMenu',
    value: function openMenu() {
      var _this2 = this;

      this.setState({
        startMove: null,
        lastMove: null,
        xOffset: this.props.menuWidth || this.defaultMenuWidth,
        isMenuOpen: true
      }, function () {
        return _this2.funcNullCheck(_this2.props.emitOpened);
      });
    }
  }, {
    key: 'closeMenu',
    value: function closeMenu() {
      var _this3 = this;

      this.setState({
        startMove: null,
        lastMove: null,
        xOffset: 0,
        isMenuOpen: false
      }, function () {
        return _this3.funcNullCheck(_this3.props.emitClosed);
      });
    }
  }, {
    key: 'trackMenuPosition',
    value: function trackMenuPosition(touchX) {
      var _state3 = this.state,
          startMove = _state3.startMove,
          isMenuOpen = _state3.isMenuOpen;

      var menuWidth = this.props.menuWidth || this.defaultMenuWidth;
      var stopPoint = isMenuOpen ? menuWidth : 0;
      var positon = stopPoint + touchX - startMove;
      var xOffset = positon >= menuWidth ? menuWidth : positon;

      this.setState({
        lastMove: touchX,
        xOffset: xOffset
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          Content = _props.Content,
          _props$zIndex = _props.zIndex,
          zIndex = _props$zIndex === undefined ? 2000 : _props$zIndex;
      var xOffset = this.state.xOffset;

      var menuWidth = this.props.menuWidth || this.defaultMenuWidth;
      var translateX = -menuWidth + xOffset;

      return _react2.default.createElement(
        'div',
        { onTouchStart: this.touchStartHandler, onTouchMove: this.touchMoveHandler, onTouchEnd: this.touchEndHandler },
        children,
        _react2.default.createElement(
          'aside',
          {
            style: {
              transform: 'translate(' + translateX + 'px, 0)',
              transition: 'transform .1s',
              position: 'fixed',
              top: '0',
              bottom: '0',
              minHeight: '100vh',
              overflowY: 'auto',
              zIndex: zIndex,
              left: '0',
              width: menuWidth
            }
          },
          Content
        )
      );
    }
  }]);

  return OffCanvas;
}(_react.Component);

OffCanvas.propTypes = {
  children: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.element]),
  Content: _propTypes2.default.element,
  emitOpened: _propTypes2.default.func,
  emitClosed: _propTypes2.default.func,
  forceOpenState: _propTypes2.default.bool,
  zIndex: _propTypes2.default.number,
  sideGrabWidth: _propTypes2.default.number,
  tollerance: _propTypes2.default.number,
  menuWidth: _propTypes2.default.number
};

exports.default = OffCanvas;